/* SCCS  @(#)nsl_base.C	1.1---95/10/13--16:36:56 */
//
// nsl_base.C
//

# include "nsl_all_kernel_include.h"

nsl_base::nsl_base(const char* str,int level)
{
	set_type(str);
	init_base(level);
}
nsl_base::nsl_base(int level)
{
	set_type("");
	init_base(level);
}
int nsl_base::init()
{
	return 1;
}
int nsl_base::init_base(int level)
{
	LEVEL = level;
//		i_parent_list = 0;
//		i_children_list = 0;
//		m_parent = 0;

	if (level == 0)
		m_children_list = new nsl_base_list(level+1);
	else
		m_children_list = 0;
		
	set_name("");
	set_index(0);
	OBJ = 0;
	set_able_fg(NSL_ON); 
	set_file_able_fg(NSL_ON); 
	data_total = 0;
	data_list = 0;
 
 	set_verbose_fg(NSL_ON); 	// 1 - run verbose
	set_print_time_fg(NSL_ON);	// '1' - print time 
	set_time_fg(0); 	// 0 - all time, 1 - t = 0 only, 2 - t > 0 only
	set_flag(0);		// user defined
	set_status(1);	
	
	return 1;
}
nsl_base::~nsl_base()
{
}
void nsl_base::append_m_child(nsl_base* b)
{
	m_children_list->append(b);
}
void nsl_base::append_i_child(nsl_base* b)
{
	i_children_list->append(b);
}

// enable, disable

int nsl_base::enable_all()
{
	enable();
	if (m_children_list != NULL)
		m_children_list->enable_all();
	return get_able_fg();
}	
int nsl_base::disable_all()
{
	disable();
	if (m_children_list != NULL)
		m_children_list->disable_all();
	return get_able_fg();
}	

// data

int nsl_base::add_data(nsl_base* obj)
{
	obj->set_index(++data_total);
	data_list->append(obj);

	return data_total;
}
nsl_base* nsl_base::get_data(const int bindex)
{
	return data_list->get_by_index(bindex);
}
nsl_base* nsl_base::get_data(const char* bname)
{
	return data_list->get_by_name(bname); // by_type
}
nsl_base* nsl_base::get_ip_data(const char* str,nsl_base* obj)
{
	nsl_base* data = 0;
	nsl_base_list* dlist = 0;

	if (obj == NULL)
		return NULL;

	if ((dlist = obj->get_data_list()) == NULL ||
		(data = dlist->get_by_name(str)) == NULL)
	{
		nsl_list* iplist = obj->get_i_parent_list();
		nsl_base* ipobj = 0;
		if (iplist == NULL)
			return NULL;
		iplist->wind_up(); // rewind parent list
		while ((ipobj = iplist->next()) != NULL)
		{
			if ((data = get_ip_data(str,ipobj)) != NULL)
				break;
		}
	}

	return data;
}

// file enable, file disable

int nsl_base::file_enable_all()
{
	file_enable();
	if (m_children_list != NULL)
		m_children_list->file_enable_all();
	return get_file_able_fg();
}	
int nsl_base::file_disable_all()
{
	file_disable();
	if (m_children_list != NULL)
		m_children_list->file_disable_all();
	return get_file_able_fg();
}	

// print 

int nsl_base::print_base(ostream& out) const
{
	out << "set " << get_abstract_type();
	out << " name " << get_name() << "\n";

 	return 1;
}
int nsl_base::print(ostream& out) const
{
	print_base(out);

 	return 1;
}
int nsl_base::print_base_status(ostream& out) const
{
 	out << "\n";
	out << "// name:\t\t" << get_name() << "\n";
	out << "// type:\t\t" << get_type() << "\n";
	out << "// base_type:\t\t" << get_base_type() << "\n";
	out << "// abstract_type:\t" << get_abstract_type() << "\n";
	out << "// index:\t\t" << get_index() << "\n";
	out << "// able_fg:\t\t";
	if (get_able_fg() == 1)
		out << "ON\n";
	else
		out << "OFF\n";
	out << "// file_able_fg:\t";
	if (get_file_able_fg() == 1)
		out << "ON\n";
	else
		out << "OFF\n";
	out.flush();

	return 1;
}
int nsl_base::print_status(ostream& out) const
{
	print_base_status(out);

 	return 1;
}

// print all

int nsl_base::print_base_all(ostream& out) const
{
	print_base(out);
	if (m_children_list != NULL)
	{
		cout << "// children: \n";
		m_children_list->print_all(out);
	}
	return 1;
}
int nsl_base::print_all(ostream&) const
{
	cmd_error("nsl_base: Nothing to print");
	return 1;
}
int nsl_base::print_base_all_status(ostream& out) const
{
	print_base_status(out);
	if (m_children_list != NULL)
	{
		cout << "// children: \n";
		m_children_list->print_all_status(out);
	}
	return 1;
}
int nsl_base::print_all_status(ostream&) const
{
	cmd_error("nsl_base: Nothing to print");
	return 1;
}

// reset

int nsl_base::reset_base(nsl_buffer*)
{
	return 1;
}
int nsl_base::reset(nsl_buffer* buf)
{
	reset_base(buf);
	return 1;
}

// read, write

int nsl_base::write_base(nsl_buffer&)
{
	return 1;
}
int nsl_base::write(nsl_buffer& buf)
{
	write_base(buf);
	return 1;
}
int nsl_base::read_base(nsl_buffer&)
{
	return 1;
}
int nsl_base::read(nsl_buffer& buf)
{
	read_base(buf);
	return 1;
}
