/* SCCS  @(#)nsl_diff_euler_vector.C	1.1---95/10/13--16:37:21 */
//
// nsl_diff_euler_vector.C
//

# include "nsl_all_kernel_include.h"

nsl_diff_euler_vector::nsl_diff_euler_vector()
{
	init_diff_euler_vector();
}
nsl_diff_euler_vector::~nsl_diff_euler_vector()
{
}

int nsl_diff_euler_vector::init_diff_euler_vector()
{
	set_type("euler_vector"); // num_vector
 
	return 1;
}

int nsl_diff_euler_vector::exec(const num_type a)
{
	*((nsl_vector*) layer) = *((nsl_vector*) layer) + p*a;

	return 1;
}
int nsl_diff_euler_vector::exec(const nsl_num_data& a)
{
	*((nsl_vector*) layer) = *((nsl_vector*) layer) + p*a;

	return 1;
}
int nsl_diff_euler_vector::exec(const nsl_num_vector& a)
{
 	*((nsl_vector*) layer) = *((nsl_vector*) layer) + p*a;
 
	return 1;
}
int nsl_diff_euler_vector::exec(const nsl_num_matrix&)
{
	cmd_error("nsl_diff_euler_vector: Bad matrix to vector conversion");

	return 1;
}

extern void NSLmult_equal(nsl_num_vector&,const nsl_num_vector&,
	const num_type&);
extern void NSLmult_plus(nsl_num_vector&,const nsl_num_vector&,
	const num_type&);

int nsl_diff_euler_vector::run(nsl_layer* out,nsl_layer* in)
{
	num_type p0 = dt/tm;
	num_type p1 = 1.0 - dt/tm;
	
	// m(t+dt) = (1-dt/tm)*m(t) + (dt/tm)*Sm
    	NSLmult_equal(*((nsl_num_vector*) out), *((nsl_num_vector*) out), p1);
	NSLmult_plus(*((nsl_num_vector*) out), *((nsl_num_vector*) in), p0);

	return 1;
}

nsl_diff_method* nsl_diff_euler_vector::make_copy()
{
	return new nsl_diff_euler_vector;
}
