/* SCCS  @(#)nsl_vector_comp_library.C	1.1---95/08/13--20:48:18 */
//
//	nsl_vector_comp_library.C
//

# include "nsl_all_kernel_include.h"

// vector convolution

// comparator

int operator>(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] > b)
			return 1;
	return 0;
}

int operator<(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] < b)
			return 1;
	return 0;
}
int operator>(const num_type a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a > b[i])
			return 1;
	return 0;
}

int operator<(const num_type a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a < b[i])
			return 1;
	return 0;
}
int operator>(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] > b)
			return 1;
	return 0;
}

int operator<(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] < b)
			return 1;
	return 0;
}
int operator>(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a > b[i])
			return 1;
	return 0;
}

int operator<(const nsl_data& a,const  nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a < b[i])
			return 1;
	return 0;
}

// >=, <=

int operator>=(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] >= b)
			return 1;
	return 0;
}

int operator<=(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] <= b)
			return 1;
	return 0;
}
int operator>=(const num_type a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a >= b[i])
			return 1;
	return 0;
}

int operator<=(const num_type a,const  nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a <= b[i])
			return 1;
	return 0;
}
int operator>=(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] >= b)
			return 1;
	return 0;
}

int operator<=(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] <= b)
			return 1;
	return 0;
}
int operator>=(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a >= b[i])
			return 1;
	return 0;
}

int operator<=(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a <= b[i])
			return 1;
	return 0;
}

// ==, !=

int operator==(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] == b)
			return 1;
	return 0;
}

int operator!=(const nsl_vector& a,const  num_type b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] != b)
			return 1;
	return 0;
}
int operator==(const num_type a,const  nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a == b[i])
			return 1;
	return 0;
}

int operator!=(const num_type a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a != b[i])
			return 1;
	return 0;
}
int operator==(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] == b)
			return 1;
	return 0;
}

int operator!=(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a[i] != b)
			return 1;
	return 0;
}
int operator==(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a == b[i])
			return 1;
	return 0;
}

int operator!=(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();

	for(int i = 0; i < aimax; i++)
		if(a != b[i])
			return 1;
	return 0;
}
