/* SCCS  @(#)nsl_matrix_expdecay_library.C	1.1---95/08/13--20:48:15 */
//
//	nsl_matrix_expdecay_library.C
//

# include "nsl_all_kernel_include.h"

nsl_matrix NSLexpdecay(nsl_matrix& T,nsl_data& kx1)
{
        int imax = T.get_imax();
        int jmax = T.get_jmax();

	nsl_matrix Q(imax,jmax);

        int i0 = T.get_i0();
        int i1 = T.get_i1();
        int j0 = T.get_j0();
        int j1 = T.get_j1();

	nsl_model* model = NSL_SYSTEM->get_model();

	if (model == NULL)
	{
		cmd_error("NSLexxpdecay: NULL model");
		return T;
	}

        num_type dt = model->get_delta();

        int i,j;
        num_type val;
        
        for (i=i0; i<=i1; i++)
            for (j=j0; j<=j1; j++)
            {
                val = exp(-dt/kx1.elem());
                Q.elem(i,j) = val*T.elem(i,j);
            }

	return Q;
}

