/************************************/
/*       nsl_link_data_data.C       */
/************************************/

# include "nsl_all_kernel_include.h"
# include "nsl_all_neuron_include.h"
  
nsl_link_data_data::nsl_link_data_data(nsl_layer& f,nsl_layer& t,
	nsl_layer& w,int s) : nsl_link_data(f,t,w,s)
{
}

nsl_link_data_data::nsl_link_data_data(nsl_layer& f,nsl_layer& t,int s) : 
	nsl_link_data(f,t,s)
{
}

nsl_link_data_data::~nsl_link_data_data()
{
}

int nsl_link_data_data::run()
{
	nsl_layer* out;

	if (link_layer != NULL)
		link_layer->print(cout);
	else
	{
		cmd_out("nsl_link_data_data::run: NULL link_layer");
		return 1;
	}

	if (from != NULL && 
		(out = from->get_output()) != NULL)
	{
		out->print(cout);
	}
	else
	{
		cmd_out("nsl_link_data_data::run: NULL from/output");
		return 1;
	}

	NSLadd_equal(*((nsl_num_data*) link_layer),*((nsl_num_data*) out));

	link_layer->print(cout);

	return 1;
}
