/* SCCS  @(#)nsl_sys_main.C	1.1---95/08/13--21:10:41 */
/**************************************************************/
/*                                                            */
/*                       nsl_sys_main.C                       */
/*                                                            */
/**************************************************************/

# include "nsl_all_kernel_include.h"
# include "nsl_all_neuron_include.h"

// extern void SchemaInit();
	
// global data definition

nsl_interpreter* NSL_INTERPRETER;
nsl_system* NSL_SYSTEM;

nsl_interpreter* nsl_base::INTERPRETER = 0;
nsl_system* nsl_base::SYSTEM = 0;
nsl_public* nsl_base::SYS_INTERFACE = 0;
int BREAKFG = 0;
int INTERRUPTFG = 0;	// set to 1 if BREAKFG has been serviced 
			// left to the user for reset

# ifdef NSL_WIN	
extern int XNSLoutput(const char*);
extern void XNSLinit(int,char**);
extern void XNSLmain(int,char**);
extern void XNSLsysinit();
# endif

extern "C" 
{
	//AW98	int NSLinit_interrupt_handler();
}

extern void nsl_neuron_init();	
extern void nsl_kernel_init();	

extern void NSLetc();

// end addition

void NSLinit(int argc = 0,char** argv = NULL)
{
	cmd_out("NSL Version 3.0");
	cmd_out("(C) Copyright 1989-1997 Brain Simulation Laboratory All Rights Reserved");
	cmd_out("Center for Neural Engineering, University of Southern California");

# ifndef NSL_WIN	
	cmd_out("Initializing NSL Simulation System...");
# else
	cmd_out("Initializing XNSL Simulation System...");
# endif

// The order is VERY important
	nsl_sys_module* sys_mod;
	sys_mod = new nsl_sys_module("kernel",nsl_kernel_init,1);

	sys_mod = new nsl_sys_module("neuron",nsl_neuron_init,1);

	NSLetc();	// call any additional library instantiations
	
# ifdef NSL_WIN	
	XNSLsysinit();  // call graphics library instantiations
# endif
	
	if (NSL_SYSTEM == NULL)
	{
		NSL_SYSTEM = new nsl_system;
 	}

	if (NSL_SYSTEM == NULL)
	{
		cmd_error("Cannot create SYSTEM");
		exit(-1);
	}

	if (NSL_INTERPRETER == NULL)
	{
		NSL_INTERPRETER = new nsl_interpreter;
 	}

	if (NSL_INTERPRETER == NULL)
	{
		cmd_error("Cannot create NSL_INTERPRETER");
		exit(-1);
	}

// AW commented out 3/96
//	NSL_SYSTEM->set_argc_ptr(&argc);
//	NSL_SYSTEM->set_argv_ptr(argv);

// init XNSL before initiating all procedures
# ifdef NSL_WIN	
	XNSLinit(argc,argv);
# endif

# ifndef __GNUG__
//	cin.sync_with_stdio(); // sync stdio with C++ streams
# endif

//AW98 NSLinit_interrupt_handler();

// initiate
        NSL.add_shell(new nsl_cmd_buf); // creating new SHELL

	NSL.init(); // init all shells and LOG

	NSL_SYSTEM->init_proc(); // initiating SHELL (nsl_sys_module)
	
//	SchemaInit();
	
	NSL_SYSTEM->init(); 	// initiating MODELS (nsl_sys_module)
}

# ifdef NSL_WIN	
void NSLmain(int argc,char** argv)
# else
void NSLmain(int,char**)
# endif
{
# ifdef NSL_WIN	
	XNSLmain(argc,argv);
# else
	NSL.run(); // used if no windows
# endif

	cmd_out("Exiting NSL Simulation System");
}

int NSLoutput(const char* str)
{
# ifdef NSL_WIN
	XNSLoutput(str);
# else
	cout << str;
	cout.flush();
# endif

	return 1;
}

int NSLoutput(const int str1)
{
	nsl_string str;

	sprintf(str,"%d",str1);
	NSLoutput(str);

	return 1;
}

int NSLoutput(const float str1)
{
	nsl_string str;

	sprintf(str,"%f",str1);
	NSLoutput(str);

	return 1;
}

int NSLoutput(const char* str1,const char* str2)
{
	NSLoutput(str1);
	NSLoutput(str2);

	return 1;
}

